com.io7m.jpra.model.type_expressions

## Class TypeExprBooleanSet<I,T>

- java.lang.Object
- - com.io7m.jpra.model.type_expressions.TypeExprBooleanSet<I,T>

- Type Parameters:
    `I` - The type of identifiers
    `T` - The type of type information
  All Implemented Interfaces:
    ModelElementType, TypeExprType<I,T>

      public final class TypeExprBooleanSet<I,T>
      extends Object
      implements TypeExprType<I,T>

  A `boolean-set` type expression.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TypeExprBooleanSet(T in_type, Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> in_lex, com.gs.collections.api.list.ImmutableList<FieldName> in_fields, SizeExprType<I,T> in_size)` Construct a type expression.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.gs.collections.api.list.ImmutableList<FieldName>` | `getFieldsInDeclarationOrder()`
    `Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>>` | `getLexicalInformation()` Fetch the lexical information for the element.
    `SizeExprType<I,T>` | `getSizeExpression()`
    `T` | `getType()`
    `<A,E extends Exception> A` | `matchType(TypeExprMatcherType<I,T,A,E> m)` Accept a matcher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TypeExprBooleanSet

          public TypeExprBooleanSet(T in_type,
                                    Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> in_lex,
                                    com.gs.collections.api.list.ImmutableList<FieldName> in_fields,
                                    SizeExprType<I,T> in_size)

      Construct a type expression.
      Parameters:
        `in_type` - The type
        `in_lex` - Lexical information
        `in_fields` - The fields of the set
        `in_size` - The size in octets that will be used

  - ### Method Detail

    - #### getFieldsInDeclarationOrder

          public com.gs.collections.api.list.ImmutableList<FieldName> getFieldsInDeclarationOrder()

      Returns:
        The fields in declaration order

    - #### getSizeExpression

          public SizeExprType<I,T> getSizeExpression()

      Returns:
        The size expression denoting the size in octets

    - #### getType

          public T getType()

      Specified by:
        `getType` in interface `TypeExprType<I,T>`
      Returns:
        The assigned expression type

    - #### matchType

          public <A,E extends Exception> A matchType(TypeExprMatcherType<I,T,A,E> m)
                                              throws E extends Exception

      Description copied from interface: `TypeExprType`
      Accept a matcher.
      Specified by:
        `matchType` in interface `TypeExprType<I,T>`
      Type Parameters:
        `A` - The type of returned values
        `E` - The type of raised exceptions
      Parameters:
        `m` - The matcher
      Returns:
        The value returned by `m`
      Throws:
        `E` - If `m` raises `E`
        `E extends Exception`

    - #### getLexicalInformation

          public Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> getLexicalInformation()

      Description copied from interface: `ModelElementType`
      Fetch the lexical information for the element. This is used to localize error messages to a position in a file when referring to specific elements.
      Specified by:
        `getLexicalInformation` in interface `ModelElementType`
      Returns:
        The original lexical information, if any

Copyright © 2015 <code@io7m.com> http://io7m.com